package genList.test;

import junit.framework.TestCase;
import genList.*;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class Test_List extends TestCase {
  
  /**
   * A test method.
   * (Replace "X" with a name describing the test.  You may write as
   * many "testSomething" methods in this class as you wish, and each
   * one will be called when running JUnit over this class.)
   */
  public void test_list() {
    List<Integer> intList = new EmptyList<Integer>();
    
    int expected = 0;
    int actual = intList.accept(SumIntListVisitor.ONLY);
    assertEquals("Sum of empty list of Integers", expected, actual);
    
    intList = intList.cons(42);
    
    expected = 42;
    actual = intList.accept(SumIntListVisitor.ONLY);
    assertEquals("sum of {42}", expected, actual);
    
    intList = intList.cons(-99);
    
    expected = -57;
    actual = intList.accept(SumIntListVisitor.ONLY);
    assertEquals("sum of {-99, 42}", expected, actual);
  }
}
